import java.awt.*;


public class CircleButton
{
    // instance variables - replace the example below with your own
    private Rectangle bounds;
    private Color color;
    private String name;
    private boolean hilight,pressed;
    private Font font=new Font("SansSerif",Font.BOLD, 14);
    /**
     * Constructor for objects of class CircleButton
     */
    public CircleButton(int x, int y, int size, String name, Color color)
    {
        this(x,y,size,size,name,color);
        
    }
    public CircleButton(int x, int y, int width, int height, String name, Color color)
    {
     
        bounds = new Rectangle(x,y,width,height);
        this.color = color;
        this.name = name;
        this.hilight=false;
        this.pressed=false;
    }

    public void draw(Graphics g)
    {
        if (hilight){ 
            g.setColor(Color.BLACK);
            g.fillOval(bounds.x-4, bounds.y-4, bounds.width+8, bounds.height+8);
        } 
        if (pressed)
            g.setColor(Color.BLACK);
        else
            g.setColor(color);
        g.fillOval(bounds.x, bounds.y, bounds.width, bounds.height);
        g.setFont(font);
        if (pressed)
            g.setColor(Color.WHITE);
        else
            g.setColor(Color.BLACK);
        int x=bounds.x+(bounds.width-name.length()*7)/2;
        int y=bounds.y+(bounds.height/2+4);
        g.drawString(name, x, y);
        
    }
    public void setHilight(boolean b){ hilight=b;}
    public boolean isHilighted() {return hilight;}
    public void setPressed(boolean b){ pressed=b;}
    public boolean isPressed() { return pressed; }
    public boolean contains(int x, int y){
        return bounds.contains(x,y);
    }
    public String getName() {return name;}
    public void setName(String s){name=s;}
    public Color getColor(){return color;}
    public void setColor(Color c){color=c;}
    public void setBounds(Rectangle r){bounds=r;}
    public Rectangle getBounds(){return bounds;}
    public int getX(){return bounds.x;}
    public int getY(){return bounds.y;}
    public int getSize(){return bounds.width;}
    public void setFont(Font f){font=f;}
    public Font getFont(){return font;}
}
