import java.util.ArrayList;
import java.awt.*;
/**
 * GestureButton is a generic Gesture, designed to be a super class of 
 * Rock, Paper, Scissors, etc.
 * 
 * @author Chris Thiel, OFMCap
 * @version Nov 25, 2011
 */
public class GestureButton extends PointingCircleButton implements Gesture
{
    private ArrayList<GestureButton> winsOver, losesTo;
    private ArrayList<String> winAction, loseAction;
    public GestureButton(int x, int y, int size, String name, Color color){
        super(x,y,size,name,color);
        winsOver = new ArrayList<GestureButton>();
        losesTo =new ArrayList<GestureButton>();
        winAction = new ArrayList<String>();
        loseAction = new ArrayList<String>();
    }
    public void winsOver(GestureButton other, String winVerb, String loseVerb){
        this.winsOver.add(other);
        this.winAction.add(winVerb);
        other.losesTo.add(this);
        other.loseAction.add(loseVerb);
        
    }
    
    public String toString()
    {
        return getName();
    }
    public int beats(Gesture g) {
       if ( winsOver.indexOf(g) >=0 )
          return 1;
       if ( losesTo.indexOf(g) >=0 )
            return -1;
       return 0;
    }

    public String action(Gesture g) {
        if (this.beats(g)>0){
            return winAction.get(winsOver.indexOf(g));      
        }
        if (this.beats(g)<0){
            return loseAction.get(losesTo.indexOf(g));
        }   
        return " ties with ";
    }
    public void draw(Graphics g)
    {
        for (GestureButton b:winsOver){
            drawArrowTo(g,b);
         }
        super.draw(g);
    }
}
