import java.awt.*;
public class PointingCircleButton extends CircleButton
{
    public PointingCircleButton(int x, int y, int size, String name, Color color){
        super(x,y,size,name,color);
    }
    public void drawArrowTo(Graphics g, CircleButton other){
        g.setColor(getColor() );
        if (isPressed() )
            g.setColor(Color.BLACK);
        int x1=getX()+getSize()/2;
        int y1=getY()+getSize()/2;
        int r=other.getSize()/2;
        int x2=other.getX()+r;
        int y2=other.getY()+r;
        double theta = Math.atan2(y2-y1,x2-x1);
        Polygon arrowShaft=new Polygon();
        int d=20;
        double t=.12;
        arrowShaft.addPoint(x1+(int)(r*Math.cos(theta+t)), y1+(int)(r*Math.sin(theta+t)) );
        arrowShaft.addPoint(x1+(int)(r*Math.cos(theta-t)), y1+(int)(r*Math.sin(theta-t)) );
        arrowShaft.addPoint(x2-(int)(r*Math.cos(theta)), y2-(int)(r*Math.sin(theta)) );
        Polygon arrowHead=new Polygon();
        arrowHead.addPoint(x2-(int)((r+d)*Math.cos(theta+t)), y2-(int)((r+d)*Math.sin(theta+t)) );
        arrowHead.addPoint(x2-(int)((r+d)*Math.cos(theta-t)), y2-(int)((r+d)*Math.sin(theta-t)) );
        arrowHead.addPoint(x2-(int)(r*Math.cos(theta)), y2-(int)(r*Math.sin(theta)) );
        
        g.fillPolygon(arrowShaft);
        g.fillPolygon(arrowHead);
    }
    public void draw(Graphics g){
        super.draw(g);
    }

}
