
import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.applet.*;
import java.util.ArrayList;
//import javax.swing.event.*;
/**
 * Class CircleButtons - write a description of the class here
 * 
 * @author (your name) 
 * @version (a version number)
 */
public class RockPaperScissorsLizardSpock extends Applet implements MouseListener,MouseMotionListener
{
    private ArrayList<GestureButton> btns;
    private String message="";
    private int human, computer,ties;
    private boolean gameOver;
    private ResetButton resetBtn;
    private SmartGuesser ai;
    private Image virtualMem;
	private BufferedImage img;
	private Graphics gBuffer;
    public void init()
    {
       human=0;
       computer=0;
       ties=0;
       gameOver=false;

       resetBtn= new ResetButton(195,220,100,75,"Play Again", Color.MAGENTA);
       resetBtn.setVisable(false);
       Ngon pattern = new Ngon(5, 20, 30, 175, -90); 
       GestureButton rock  = new GestureButton(pattern.getX(0),pattern.getY(0),100,"Rock",Color.CYAN );
       GestureButton paper = new GestureButton(pattern.getX(1),pattern.getY(1),100,"Paper", Color.RED );
       GestureButton scissors = new GestureButton(pattern.getX(2),pattern.getY(2),100, "Scissors", new Color(210,125,255));
       GestureButton lizard = new GestureButton(pattern.getX(3),pattern.getY(3),100,"Lizard", Color.ORANGE );
       GestureButton spock = new GestureButton(pattern.getX(4),pattern.getY(4),100, "Spock", Color.GREEN );
       
       rock.winsOver(scissors," crushes ", " crushed by ");
       paper.winsOver(rock, " covers ", " covered by ");
       scissors.winsOver(paper, " cuts ", " cut by ");
       lizard.winsOver(paper, " eats ", " eaten by ");
       spock.winsOver(rock, " vaporizes ", " vaporized by ");
       
       rock.winsOver(lizard," crushes ", " crushed by ");
       paper.winsOver(spock, " disproves ", " disproved by ");
       scissors.winsOver(lizard, " decapitates ", " decapitated by ");
       lizard.winsOver(spock, " poisons ", " poisoned by ");
       spock.winsOver(scissors, " smashes ", " smashed by ");
       
       btns=new ArrayList<GestureButton>();
       btns.add(rock);
       btns.add(paper);
       btns.add(scissors);
       btns.add(lizard);
       btns.add(spock);
       ai=new SmartGuesser(btns);      
       addMouseListener(this);
       addMouseMotionListener(this);
       virtualMem = createImage(getWidth(),getHeight());
       gBuffer = virtualMem.getGraphics();
    }

    

    /**
     * Paint method for applet.
     * 
     * @param  g   the Graphics object for this applet
     */
    public void paint(Graphics g)
    {
        // simple text displayed on applet
    		gBuffer.setColor(Color.white);
        gBuffer.fillRect(0, 0, getWidth(), getHeight());
        gBuffer.setColor(Color.black);
        gBuffer.drawString("Rock Paper Scissors Lizard Spock (with basic AI)", 20, 20);
        gBuffer.setColor(Color.blue);
        gBuffer.drawString(message, 150, 470);
        gBuffer.drawString("You: "+human, 58, 60);
        gBuffer.drawString("Computer: "+computer, 20, 80);
        gBuffer.drawString("Ties: "+ties, 55, 100);
        resetBtn.draw(gBuffer);
        for(GestureButton gesture:btns){
            gesture.draw(gBuffer);
        }
        g.drawImage(virtualMem,0,0,this);
    }
    public void mouseClicked(MouseEvent e){}
    public void mousePressed(MouseEvent e){
         int x=e.getX();
          int y=e.getY();
          if(!gameOver)
        	  	for(CircleButton c:btns)
                c.setPressed(c.contains(x,y));
          resetBtn.setPressed(resetBtn.contains(x, y)); 
          repaint();
    }
    public void mouseReleased(MouseEvent e){
        int x=e.getX();
        int y=e.getY();
        if(!gameOver)
        		for(GestureButton c:btns){
              c.setPressed(false);
              if(c.contains(x,y))
                  doButton(c);            
        }else{
        		if(resetBtn.contains(x, y)){
        			gameOver=false;
        			resetBtn.setVisable(false);
        			if (message.length()>2)
        				message=message.substring(message.indexOf(" "))+" last time";
        			for(CircleButton c:btns)
                        c.setPressed(false);
        		}
        }
        
        repaint();
    }
    public void mouseEntered(MouseEvent e){}
    public void mouseExited(MouseEvent e){}
    public void mouseMoved(MouseEvent e){
          int x=e.getX();
          int y=e.getY();
          if(!gameOver)
        	  	for(CircleButton c:btns){
                c.setHilight(c.contains(x,y));
                //c.setPressed(false);
            }
          resetBtn.setHilight(resetBtn.contains(x, y));
          repaint();
    }
    public void mouseDragged(MouseEvent e){}
    public void doButton(GestureButton b) {
    		gameOver=true;
        GestureButton rand=btns.get(ai.getGuess());
        ai.record(btns.indexOf(b));
        rand.setHilight(true);
        b.setHilight(true);
        if (rand.beats(b)==0){
        		message="Tie! ";
        		ties++;
        }else if (rand.beats(b)>0){
            rand.setPressed(true);
            b.setPressed(false);
            message="Sorry, ";
            computer++;
        }else if (b.beats(rand)>0){
            b.setPressed(true);
            rand.setPressed(false);
            message="Yes! ";
            human++;
        }
        
        resetBtn.setVisable(true);       
        message+=b.getName()+b.action(rand)+rand.getName();
        repaint();
    }
    public void update(Graphics g){ paint(g); }
}
